<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head profile="http://dublincore.org/documents/2008/08/04/dc-html/">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta name="robots" content="index,follow" />
    <meta name="creator" content="rfcmarkup version 1.119" />
    <link rel="schema.DC" href="http://purl.org/dc/elements/1.1/" />
<meta name="DC.Relation.Replaces" content="draft-saintandre-xmpp-tls" />
<meta name="DC.Identifier" content="urn:ietf:rfc:7590" />
<meta name="DC.Date.Issued" content="June, 2015" />
<meta name="DC.Creator" content="Peter Saint-Andre &lt;peter@andyet.com&gt;" />
<meta name="DC.Description.Abstract" content="This document provides recommendations for the use of Transport Layer
Security (TLS) in the Extensible Messaging and Presence Protocol
(XMPP). This document updates RFC 6120." />
<meta name="DC.Title" content="Use of Transport Layer Security (TLS) in the Extensible Messaging and Presence Protocol (XMPP)" />

    <link rel="icon" href="/images/rfc.png" type="image/png" />
    <link rel="shortcut icon" href="/images/rfc.png" type="image/png" />
    <title>RFC 7590 - Use of Transport Layer Security (TLS) in the Extensible Messaging and Presence Protocol (XMPP)</title>
    
    
    <style type="text/css">
	@media only screen 
	  and (min-width: 992px)
	  and (max-width: 1199px) {
	    body { font-size: 14pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-width: 768px)
	  and (max-width: 991px) {
            body { font-size: 14pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-width: 480px)
	  and (max-width: 767px) {
            body { font-size: 11pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (max-width: 479px) {
            body { font-size: 8pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-device-width : 375px) 
	  and (max-device-width : 667px) {
            body { font-size: 9.5pt; }
            div.content { width: 96ex; margin: 0 1px; }
        }
	@media only screen 
	  and (min-device-width: 1200px) {
            body { font-size: 10pt; margin: 0 4em; }
            div.content { width: 96ex; margin: 0; }
        }
        h1, h2, h3, h4, h5, h6, .h1, .h2, .h3, .h4, .h5, .h6 {
	    font-weight: bold;
            line-height: 0pt;
            display: inline;
            white-space: pre;
            font-family: monospace;
            font-size: 1em;
	    font-weight: bold;
        }
        pre {
            font-size: 1em;
            margin-top: 0px;
            margin-bottom: 0px;
        }
	.pre {
	    white-space: pre;
	    font-family: monospace;
	}
	.header{
	    font-weight: bold;
	}
        .newpage {
            page-break-before: always;
        }
        .invisible {
            text-decoration: none;
            color: white;
        }
        a.selflink {
          color: black;
          text-decoration: none;
        }
        @media print {
            body {
                font-family: monospace;
                font-size: 10.5pt;
            }
            h1, h2, h3, h4, h5, h6 {
                font-size: 1em;
            }
        
            a:link, a:visited {
                color: inherit;
                text-decoration: none;
            }
            .noprint {
                display: none;
            }
        }
	@media screen {
	    .grey, .grey a:link, .grey a:visited {
		color: #777;
	    }
            .docinfo {
                background-color: #EEE;
            }
            .top {
                border-top: 7px solid #EEE;
            }
            .bgwhite  { background-color: white; }
            .bgred    { background-color: #F44; }
            .bggrey   { background-color: #666; }
            .bgbrown  { background-color: #840; }            
            .bgorange { background-color: #FA0; }
            .bgyellow { background-color: #EE0; }
            .bgmagenta{ background-color: #F4F; }
            .bgblue   { background-color: #66F; }
            .bgcyan   { background-color: #4DD; }
            .bggreen  { background-color: #4F4; }

            .legend   { font-size: 90%; }
            .cplate   { font-size: 70%; border: solid grey 1px; }
	}
    </style>
    <!--[if IE]>
    <style>
    body {
       font-size: 13px;
       margin: 10px 10px;
    }
    </style>
    <![endif]-->

    <script type="text/javascript"><!--
    function addHeaderTags() {
	var spans = document.getElementsByTagName("span");
	for (var i=0; i < spans.length; i++) {
	    var elem = spans[i];
	    if (elem) {
		var level = elem.getAttribute("class");
                if (level == "h1" || level == "h2" || level == "h3" || level == "h4" || level == "h5" || level == "h6") {
                    elem.innerHTML = "<"+level+">"+elem.innerHTML+"</"+level+">";		
                }
	    }
	}
    }
    var legend_html = "Colour legend:<br />      <table>         <tr><td>Unknown:</td>                   <td><span class='cplate bgwhite'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Draft:</td>                     <td><span class='cplate bgred'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Informational:</td>             <td><span class='cplate bgorange'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Experimental:</td>              <td><span class='cplate bgyellow'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Best Common Practice:</td>      <td><span class='cplate bgmagenta'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Proposed Standard:</td>         <td><span class='cplate bgblue'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Draft Standard (old designation):</td> <td><span class='cplate bgcyan'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Internet Standard:</td>         <td><span class='cplate bggreen'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Historic:</td>                  <td><span class='cplate bggrey'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Obsolete:</td>                  <td><span class='cplate bgbrown'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>     </table>";
    function showElem(id) {
        var elem = document.getElementById(id);
        elem.innerHTML = eval(id+"_html");
        elem.style.visibility='visible';
    }
    function hideElem(id) {
        var elem = document.getElementById(id);
        elem.style.visibility='hidden';        
        elem.innerHTML = "";
    }
    // -->
    </script>
</head>
<body onload="addHeaderTags()">
  <div class="content">
   <div style="height: 13px;">
      <div onmouseover="this.style.cursor='pointer';"
         onclick="showElem('legend');"
         onmouseout="hideElem('legend')"
	 style="height: 6px; position: absolute;"
         class="pre noprint docinfo bgblue"
         title="Click for colour legend." >                                                                        </div>
      <div id="legend"
           class="docinfo noprint pre legend"
           style="position:absolute; top: 4px; left: 4ex; visibility:hidden; background-color: white; padding: 4px 9px 5px 7px; border: solid #345 1px; "
           onmouseover="showElem('legend');"
           onmouseout="hideElem('legend');">
      </div>
   </div>
<span class="pre noprint docinfo top">[<a href="../html/" title="Document search and retrieval page">Docs</a>] [<a href="/rfc/rfc7590.txt" title="Plaintext version of this document">txt</a>|<a href="/pdf/rfc7590" title="PDF version of this document">pdf</a>] [<a href="./draft-ietf-uta-xmpp" title="draft-ietf-uta-xmpp">draft-ietf-uta-xmpp</a>] [<a href="/rfcdiff?difftype=--hwdiff&amp;url2=rfc7590" title="Inline diff (wdiff)">Diff1</a>] [<a href="/rfcdiff?url2=rfc7590" title="Side-by-side diff">Diff2</a>]                  </span><br />
<span class="pre noprint docinfo">                                                                        </span><br />
<span class="pre noprint docinfo">                                                       PROPOSED STANDARD</span><br />
<span class="pre noprint docinfo">                                                                        </span><br />
<pre>
Internet Engineering Task Force (IETF)                    P. Saint-Andre
Request for Comments: 7590                                          &amp;yet
Updates: <a href="./rfc6120">6120</a>                                                T. Alkemade
Category: Standards Track                                      June 2015
ISSN: 2070-1721


              <span class="h1">Use of Transport Layer Security (TLS) in the</span>
           <span class="h1">Extensible Messaging and Presence Protocol (XMPP)</span>

Abstract

   This document provides recommendations for the use of Transport Layer
   Security (TLS) in the Extensible Messaging and Presence Protocol
   (XMPP).  This document updates <a href="./rfc6120">RFC 6120</a>.

Status of This Memo

   This is an Internet Standards Track document.

   This document is a product of the Internet Engineering Task Force
   (IETF).  It represents the consensus of the IETF community.  It has
   received public review and has been approved for publication by the
   Internet Engineering Steering Group (IESG).  Further information on
   Internet Standards is available in <a href="./rfc5741#section-2">Section&nbsp;2 of RFC 5741</a>.

   Information about the current status of this document, any errata,
   and how to provide feedback on it may be obtained at
   <a href="http://www.rfc-editor.org/info/rfc7590">http://www.rfc-editor.org/info/rfc7590</a>.

Copyright Notice

   Copyright (c) 2015 IETF Trust and the persons identified as the
   document authors.  All rights reserved.

   This document is subject to <a href="./bcp78">BCP 78</a> and the IETF Trust's Legal
   Provisions Relating to IETF Documents
   (<a href="http://trustee.ietf.org/license-info">http://trustee.ietf.org/license-info</a>) in effect on the date of
   publication of this document.  Please review these documents
   carefully, as they describe your rights and restrictions with respect
   to this document.  Code Components extracted from this document must
   include Simplified BSD License text as described in Section 4.e of
   the Trust Legal Provisions and are provided without warranty as
   described in the Simplified BSD License.







<span class="grey">Saint-Andre &amp; Alkemade       Standards Track                    [Page 1]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-2" id="page-2" href="#page-2" class="invisible"> </a>
<span class="grey"><a href="./rfc7590">RFC 7590</a>                        XMPP TLS                       June 2015</span>


Table of Contents

   <a href="#section-1">1</a>.  Introduction  . . . . . . . . . . . . . . . . . . . . . . . .   <a href="#page-2">2</a>
   <a href="#section-2">2</a>.  Terminology . . . . . . . . . . . . . . . . . . . . . . . . .   <a href="#page-2">2</a>
   <a href="#section-3">3</a>.  Recommendations . . . . . . . . . . . . . . . . . . . . . . .   <a href="#page-3">3</a>
     <a href="#section-3.1">3.1</a>.  Support for TLS . . . . . . . . . . . . . . . . . . . . .   <a href="#page-3">3</a>
     <a href="#section-3.2">3.2</a>.  Compression . . . . . . . . . . . . . . . . . . . . . . .   <a href="#page-3">3</a>
     <a href="#section-3.3">3.3</a>.  Session Resumption  . . . . . . . . . . . . . . . . . . .   <a href="#page-3">3</a>
     <a href="#section-3.4">3.4</a>.  Authenticated Connections . . . . . . . . . . . . . . . .   <a href="#page-4">4</a>
     <a href="#section-3.5">3.5</a>.  Server Name Indication  . . . . . . . . . . . . . . . . .   <a href="#page-5">5</a>
     <a href="#section-3.6">3.6</a>.  Human Factors . . . . . . . . . . . . . . . . . . . . . .   <a href="#page-5">5</a>
   <a href="#section-4">4</a>.  Security Considerations . . . . . . . . . . . . . . . . . . .   <a href="#page-5">5</a>
   <a href="#section-5">5</a>.  References  . . . . . . . . . . . . . . . . . . . . . . . . .   <a href="#page-6">6</a>
     <a href="#section-5.1">5.1</a>.  Normative References  . . . . . . . . . . . . . . . . . .   <a href="#page-6">6</a>
     <a href="#section-5.2">5.2</a>.  Informative References  . . . . . . . . . . . . . . . . .   <a href="#page-7">7</a>
   <a href="#appendix-A">Appendix A</a>.  Implementation Notes . . . . . . . . . . . . . . . .   <a href="#page-9">9</a>
   Acknowledgements  . . . . . . . . . . . . . . . . . . . . . . . .   <a href="#page-9">9</a>
   Authors' Addresses  . . . . . . . . . . . . . . . . . . . . . . .   <a href="#page-9">9</a>

<span class="h2"><a class="selflink" name="section-1" href="#section-1">1</a>.  Introduction</span>

   The Extensible Messaging and Presence Protocol (XMPP) [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>]
   (along with its precursor, the so-called "Jabber protocol") has used
   Transport Layer Security (TLS) [<a href="./rfc5246" title="&quot;The Transport Layer Security (TLS) Protocol Version 1.2&quot;">RFC5246</a>] (along with its precursor,
   Secure Sockets Layer or SSL) since 1999.  Both [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>] and its
   predecessor [<a href="./rfc3920" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC3920</a>] provided recommendations regarding the use of
   TLS in XMPP.  In order to address the evolving threat model on the
   Internet today, this document provides stronger recommendations.

   In particular, this document updates [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>] by specifying that
   XMPP implementations and deployments MUST follow the best current
   practices documented in the "Recommendations for Secure Use of TLS
   and DTLS" [<a href="./rfc7525" title="&quot;Recommendations for Secure Use of Transport Layer Security (TLS) and Datagram Transport Layer Security (DTLS)&quot;">RFC7525</a>].  This includes stronger recommendations
   regarding SSL/TLS protocol versions, fallback to lower versions,
   TLS-layer compression, TLS session resumption, cipher suites, public
   key lengths, forward secrecy, and other aspects of using TLS with
   XMPP.

<span class="h2"><a class="selflink" name="section-2" href="#section-2">2</a>.  Terminology</span>

   Various security-related terms are to be understood in the sense
   defined in [<a href="./rfc4949" title="&quot;Internet Security Glossary, Version 2&quot;">RFC4949</a>].

   The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
   "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and
   "OPTIONAL" in this document are to be interpreted as described in
   [<a href="./rfc2119" title="&quot;Key words for use in RFCs to Indicate Requirement Levels&quot;">RFC2119</a>].




<span class="grey">Saint-Andre &amp; Alkemade       Standards Track                    [Page 2]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-3" id="page-3" href="#page-3" class="invisible"> </a>
<span class="grey"><a href="./rfc7590">RFC 7590</a>                        XMPP TLS                       June 2015</span>


<span class="h2"><a class="selflink" name="section-3" href="#section-3">3</a>.  Recommendations</span>

   The best current practices documented in the "Recommendations for
   Secure Use of TLS and DTLS" [<a href="./rfc7525" title="&quot;Recommendations for Secure Use of Transport Layer Security (TLS) and Datagram Transport Layer Security (DTLS)&quot;">RFC7525</a>] are included here by reference.
   Instead of repeating those recommendations here, this document mostly
   provides supplementary information regarding secure implementation
   and deployment of XMPP technologies.

<span class="h3"><a class="selflink" name="section-3.1" href="#section-3.1">3.1</a>.  Support for TLS</span>

   Support for TLS (specifically, the XMPP profile of STARTTLS) is
   mandatory for XMPP implementations, as already specified in [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>]
   and its predecessor [<a href="./rfc3920" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC3920</a>].

   The server (i.e., the XMPP receiving entity) to which a client or
   peer server (i.e., the XMPP initiating entity) connects might not
   offer a stream feature of &lt;starttls xmlns='urn:ietf:params:xml:ns
   :xmpp-tls'/&gt;.  Although in general this stream feature indicates that
   the server supports and offers TLS, this stream feature might be
   stripped out by an attacker (see <a href="./rfc7457#section-2.1">Section&nbsp;2.1 of [RFC7457]</a>).
   Similarly, the &lt;required/&gt; child element of the &lt;starttls/&gt; stream
   feature is used to indicate that negotiation of TLS is mandatory;
   however, this could also be stripped out by an attacker.  Therefore,
   the initiating entity MUST NOT be deterred from attempting TLS
   negotiation even if the receiving entity does not advertise support
   for TLS.  Instead, the initiating entity SHOULD (based on local
   policy) proceed with the stream negotiation and attempt to negotiate
   TLS.

<span class="h3"><a class="selflink" name="section-3.2" href="#section-3.2">3.2</a>.  Compression</span>

   XMPP supports an application-layer compression technology [<a href="#ref-XEP-0138" title="&quot;Stream Compression&quot;">XEP-0138</a>].
   Although this XMPP extension might have slightly stronger security
   properties than TLS-layer compression (since it is enabled after
   Simple Authentication and Security Layer (SASL) authentication, as
   described in [<a href="#ref-XEP-0170" title="&quot;Recommended Order of Stream Feature Negotiation&quot;">XEP-0170</a>]), this document neither encourages nor
   discourages use of XMPP-layer compression.

<span class="h3"><a class="selflink" name="section-3.3" href="#section-3.3">3.3</a>.  Session Resumption</span>

   To improve the reliability of communications over XMPP, it is common
   practice for clients and servers to implement the stream management
   extension [<a href="#ref-XEP-0198" title="&quot;Stream Management&quot;">XEP-0198</a>].  Although that specification includes a method
   for resumption of XMPP streams at the application layer, also using
   session resumption at the TLS layer further optimizes the overall
   process of resuming an XMPP session (see [<a href="#ref-XEP-0198" title="&quot;Stream Management&quot;">XEP-0198</a>] for detailed
   information).  Whether or not XEP-0198 is used for application-layer




<span class="grey">Saint-Andre &amp; Alkemade       Standards Track                    [Page 3]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-4" id="page-4" href="#page-4" class="invisible"> </a>
<span class="grey"><a href="./rfc7590">RFC 7590</a>                        XMPP TLS                       June 2015</span>


   session resumption, implementations MUST follow the recommendations
   provided in [<a href="./rfc7525" title="&quot;Recommendations for Secure Use of Transport Layer Security (TLS) and Datagram Transport Layer Security (DTLS)&quot;">RFC7525</a>] regarding TLS-layer session resumption.

<span class="h3"><a class="selflink" name="section-3.4" href="#section-3.4">3.4</a>.  Authenticated Connections</span>

   Both the core XMPP specification [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>] and the CertID
   specification [<a href="./rfc6125" title="&quot;Representation and Verification of Domain-Based Application Service Identity within Internet Public Key Infrastructure Using X.509 (PKIX) Certificates in the Context of Transport Layer Security (TLS)&quot;">RFC6125</a>] provide recommendations and requirements for
   certificate validation in the context of authenticated connections.
   This document does not supersede those specifications (e.g., it does
   not modify the recommendations in [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>] regarding the Subject
   Alternative Names or other certificate details that need to be
   supported for authentication of XMPP connections using PKIX
   certificates).

   Wherever possible, it is best to prefer authenticated connections
   (along with SASL [<a href="./rfc4422" title="&quot;Simple Authentication and Security Layer (SASL)&quot;">RFC4422</a>]), as already stated in the core XMPP
   specification [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>].  In particular:

   o  Clients MUST authenticate servers.

   o  Servers MUST authenticate clients.

   o  Servers SHOULD authenticate other servers.

   This document does not mandate that servers need to authenticate peer
   servers, although such authentication is strongly preferred.
   Unfortunately, in multi-tenanted environments it can be extremely
   difficult to obtain and deploy PKIX certificates with the proper
   Subject Alternative Names (see [<a href="#ref-XMPP-DNA" title="&quot;Domain Name Associations (DNA) in the Extensible Messaging and Presence Protocol (XMPP)&quot;">XMPP-DNA</a>] and [<a href="#ref-PKIX-POSH" title="&quot;PKIX over Secure HTTP (POSH)&quot;">PKIX-POSH</a>] for
   details).  To overcome that difficulty, the Domain Name Associations
   (DNAs) specification [<a href="#ref-XMPP-DNA" title="&quot;Domain Name Associations (DNA) in the Extensible Messaging and Presence Protocol (XMPP)&quot;">XMPP-DNA</a>] describes a framework for XMPP server
   authentication methods, which include not only PKIX but also DNS-
   Based Authentication of Named Entities (DANE) as defined in
   [<a href="#ref-DANE-SRV" title="&quot;Using DNS- Based Authentication of Named Entities (DANE) TLSA records with SRV and MX records.&quot;">DANE-SRV</a>] and PKIX over Secure HTTP (POSH) as defined in
   [<a href="#ref-PKIX-POSH" title="&quot;PKIX over Secure HTTP (POSH)&quot;">PKIX-POSH</a>].  These methods can provide a basis for server identity
   verification when appropriate PKIX certificates cannot be obtained
   and deployed.

   Given the pervasiveness of eavesdropping [<a href="./rfc7258" title="&quot;Pervasive Monitoring Is an Attack&quot;">RFC7258</a>], even an encrypted
   but unauthenticated connection might be better than an unencrypted
   connection in these scenarios (this is similar to the "better-than-
   nothing security" approach for IPsec [<a href="./rfc5386" title="&quot;Better-Than-Nothing Security: An Unauthenticated Mode of IPsec&quot;">RFC5386</a>]).  Encrypted but
   unauthenticated connections include connections negotiated using
   anonymous Diffie-Hellman mechanisms or using self-signed
   certificates, among others.  In particular for XMPP server-to-server
   interactions, it can be reasonable for XMPP server implementations to
   accept encrypted but unauthenticated connections when Server Dialback
   keys [<a href="#ref-XEP-0220" title="&quot;Server Dialback&quot;">XEP-0220</a>] are used; such keys on their own provide only weak



<span class="grey">Saint-Andre &amp; Alkemade       Standards Track                    [Page 4]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-5" id="page-5" href="#page-5" class="invisible"> </a>
<span class="grey"><a href="./rfc7590">RFC 7590</a>                        XMPP TLS                       June 2015</span>


   identity verification (made stronger through the use of DNSSEC
   [<a href="./rfc4033" title="&quot;DNS Security Introduction and Requirements&quot;">RFC4033</a>]), but this at least enables encryption of server-to-server
   connections.  The DNA prooftypes mentioned above are intended to
   mitigate the residual need for encrypted but unauthenticated
   connections in these scenarios.

<span class="h3"><a class="selflink" name="section-3.5" href="#section-3.5">3.5</a>.  Server Name Indication</span>

   Although there is no harm in supporting the TLS Server Name
   Indication (SNI) extension [<a href="./rfc6066" title="&quot;Transport Layer Security (TLS) Extensions: Extension Definitions&quot;">RFC6066</a>], this is not necessary since the
   same function is served in XMPP by the 'to' address of the initial
   stream header as explained in <a href="./rfc6120#section-4.7.2">Section&nbsp;4.7.2 of [RFC6120]</a>.

<span class="h3"><a class="selflink" name="section-3.6" href="#section-3.6">3.6</a>.  Human Factors</span>

   It is strongly encouraged that XMPP clients provide ways for end
   users (and that XMPP servers provide ways for administrators) to
   complete the following tasks:

   o  Determine if a given incoming or outgoing XML stream is encrypted
      using TLS.

   o  Determine the version of TLS used for encryption of a given
      stream.

   o  If authenticated encryption is used, determine how the connection
      was authenticated or verified (e.g., via PKI, DANE, POSH, or
      Server Dialback).

   o  Inspect the certificate offered by an XMPP server.

   o  Determine the cipher suite used to encrypt a connection.

   o  Be warned if the certificate changes for a given server.

<span class="h2"><a class="selflink" name="section-4" href="#section-4">4</a>.  Security Considerations</span>

   The use of TLS can help to limit the information available for
   correlation between the XMPP application layer and the underlying
   network and transport layers.  As typically deployed, XMPP
   technologies do not leave application-layer routing data (such as
   XMPP 'to' and 'from' addresses) at rest on intermediate systems,
   since there is only one hop between any two given XMPP servers.  As a
   result, encrypting all hops (sender's client to sender's server,
   sender's server to recipient's server, and recipient's server to
   recipient's client) can help to limit the amount of metadata that
   might leak.




<span class="grey">Saint-Andre &amp; Alkemade       Standards Track                    [Page 5]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-6" id="page-6" href="#page-6" class="invisible"> </a>
<span class="grey"><a href="./rfc7590">RFC 7590</a>                        XMPP TLS                       June 2015</span>


   It is possible that XMPP servers themselves might be compromised.  In
   that case, per-hop encryption would not protect XMPP communications,
   and even end-to-end encryption of (parts of) XMPP stanza payloads
   would leave addressing information and XMPP roster data in the clear.
   By the same token, it is possible that XMPP clients (or the end-user
   devices on which such clients are installed) could also be
   compromised, leaving users utterly at the mercy of an adversary.

   This document and related actions to strengthen the security of the
   XMPP network are based on the assumption that XMPP servers and
   clients have not been subject to widespread compromise.  If this
   assumption is valid, then ubiquitous use of per-hop TLS channel
   encryption and more significant deployment of end-to-end object
   encryption technologies will serve to protect XMPP communications to
   a measurable degree, compared to the alternatives.

   This document covers only communication over the XMPP network and
   does not take into account gateways to non-XMPP networks.  As an
   example, for security considerations related to gateways between XMPP
   and the Session Initiation Protocol (SIP), see [<a href="./rfc7247" title="&quot;Interworking between the Session Initiation Protocol (SIP) and the Extensible Messaging and Presence Protocol (XMPP): Architecture, Addresses, and Error Handling&quot;">RFC7247</a>] and
   [<a href="./rfc7572" title="&quot;Interworking between the Session Initiation Protocol (SIP) and the Extensible Messaging and Presence Protocol (XMPP): Instant Messaging&quot;">RFC7572</a>].

<span class="h2"><a class="selflink" name="section-5" href="#section-5">5</a>.  References</span>

<span class="h3"><a class="selflink" name="section-5.1" href="#section-5.1">5.1</a>.  Normative References</span>

   [<a name="ref-RFC2119" id="ref-RFC2119">RFC2119</a>]   Bradner, S., "Key words for use in RFCs to Indicate
               Requirement Levels", <a href="./bcp14">BCP 14</a>, <a href="./rfc2119">RFC 2119</a>,
               DOI 10.17487/RFC2119, March 1997,
               &lt;<a href="http://www.rfc-editor.org/info/rfc2119">http://www.rfc-editor.org/info/rfc2119</a>&gt;.

   [<a name="ref-RFC4949" id="ref-RFC4949">RFC4949</a>]   Shirey, R., "Internet Security Glossary, Version 2",
               FYI 36, <a href="./rfc4949">RFC 4949</a>, DOI 10.17487/RFC4949, August 2007,
               &lt;<a href="http://www.rfc-editor.org/info/rfc4949">http://www.rfc-editor.org/info/rfc4949</a>&gt;.

   [<a name="ref-RFC5246" id="ref-RFC5246">RFC5246</a>]   Dierks, T. and E. Rescorla, "The Transport Layer Security
               (TLS) Protocol Version 1.2", <a href="./rfc5246">RFC 5246</a>,
               DOI 10.17487/RFC5246, August 2008,
               &lt;<a href="http://www.rfc-editor.org/info/rfc5246">http://www.rfc-editor.org/info/rfc5246</a>&gt;.

   [<a name="ref-RFC6120" id="ref-RFC6120">RFC6120</a>]   Saint-Andre, P., "Extensible Messaging and Presence
               Protocol (XMPP): Core", <a href="./rfc6120">RFC 6120</a>, DOI 10.17487/RFC6120,
               March 2011, &lt;<a href="http://www.rfc-editor.org/info/rfc6120">http://www.rfc-editor.org/info/rfc6120</a>&gt;.








<span class="grey">Saint-Andre &amp; Alkemade       Standards Track                    [Page 6]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-7" id="page-7" href="#page-7" class="invisible"> </a>
<span class="grey"><a href="./rfc7590">RFC 7590</a>                        XMPP TLS                       June 2015</span>


   [<a name="ref-RFC6125" id="ref-RFC6125">RFC6125</a>]   Saint-Andre, P. and J. Hodges, "Representation and
               Verification of Domain-Based Application Service Identity
               within Internet Public Key Infrastructure Using X.509
               (PKIX) Certificates in the Context of Transport Layer
               Security (TLS)", <a href="./rfc6125">RFC 6125</a>, DOI 10.17487/RFC6125, March
               2011, &lt;<a href="http://www.rfc-editor.org/info/rfc6125">http://www.rfc-editor.org/info/rfc6125</a>&gt;.

   [<a name="ref-RFC7525" id="ref-RFC7525">RFC7525</a>]   Sheffer, Y., Holz, R., and P. Saint-Andre,
               "Recommendations for Secure Use of Transport Layer
               Security (TLS) and Datagram Transport Layer Security
               (DTLS)", <a href="./bcp195">BCP 195</a>, <a href="./rfc7525">RFC 7525</a>, DOI 10.17487/RFC7525, May
               2015, &lt;<a href="http://www.rfc-editor.org/info/rfc7525">http://www.rfc-editor.org/info/rfc7525</a>&gt;.

<span class="h3"><a class="selflink" name="section-5.2" href="#section-5.2">5.2</a>.  Informative References</span>

   [<a name="ref-DANE-SRV" id="ref-DANE-SRV">DANE-SRV</a>]  Finch, T., Miller, M., and P. Saint-Andre, "Using DNS-
               Based Authentication of Named Entities (DANE) TLSA
               records with SRV and MX records.", Work in Progress,
               <a href="./draft-ietf-dane-srv-14">draft-ietf-dane-srv-14</a>, April 2015.

   [<a name="ref-PKIX-POSH" id="ref-PKIX-POSH">PKIX-POSH</a>] Miller, M. and P. Saint-Andre, "PKIX over Secure HTTP
               (POSH)", Work in Progress, <a href="./draft-ietf-xmpp-posh-04">draft-ietf-xmpp-posh-04</a>,
               February 2015.

   [<a name="ref-RFC3920" id="ref-RFC3920">RFC3920</a>]   Saint-Andre, P., Ed., "Extensible Messaging and Presence
               Protocol (XMPP): Core", <a href="./rfc3920">RFC 3920</a>, DOI 10.17487/RFC3920,
               October 2004, &lt;<a href="http://www.rfc-editor.org/info/rfc3920">http://www.rfc-editor.org/info/rfc3920</a>&gt;.

   [<a name="ref-RFC4033" id="ref-RFC4033">RFC4033</a>]   Arends, R., Austein, R., Larson, M., Massey, D., and S.
               Rose, "DNS Security Introduction and Requirements",
               <a href="./rfc4033">RFC 4033</a>, DOI 10.17487/RFC4033, March 2005,
               &lt;<a href="http://www.rfc-editor.org/info/rfc4033">http://www.rfc-editor.org/info/rfc4033</a>&gt;.

   [<a name="ref-RFC4422" id="ref-RFC4422">RFC4422</a>]   Melnikov, A., Ed. and K. Zeilenga, Ed., "Simple
               Authentication and Security Layer (SASL)", <a href="./rfc4422">RFC 4422</a>,
               DOI 10.17487/RFC4422, June 2006,
               &lt;<a href="http://www.rfc-editor.org/info/rfc4422">http://www.rfc-editor.org/info/rfc4422</a>&gt;.

   [<a name="ref-RFC5386" id="ref-RFC5386">RFC5386</a>]   Williams, N. and M. Richardson, "Better-Than-Nothing
               Security: An Unauthenticated Mode of IPsec", <a href="./rfc5386">RFC 5386</a>,
               DOI 10.17487/RFC5386, November 2008,
               &lt;<a href="http://www.rfc-editor.org/info/rfc5386">http://www.rfc-editor.org/info/rfc5386</a>&gt;.

   [<a name="ref-RFC6066" id="ref-RFC6066">RFC6066</a>]   Eastlake 3rd, D., "Transport Layer Security (TLS)
               Extensions: Extension Definitions", <a href="./rfc6066">RFC 6066</a>,
               DOI 10.17487/RFC6066, January 2011,
               &lt;<a href="http://www.rfc-editor.org/info/rfc6066">http://www.rfc-editor.org/info/rfc6066</a>&gt;.




<span class="grey">Saint-Andre &amp; Alkemade       Standards Track                    [Page 7]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-8" id="page-8" href="#page-8" class="invisible"> </a>
<span class="grey"><a href="./rfc7590">RFC 7590</a>                        XMPP TLS                       June 2015</span>


   [<a name="ref-RFC7247" id="ref-RFC7247">RFC7247</a>]   Saint-Andre, P., Houri, A., and J. Hildebrand,
               "Interworking between the Session Initiation Protocol
               (SIP) and the Extensible Messaging and Presence Protocol
               (XMPP): Architecture, Addresses, and Error Handling",
               <a href="./rfc7247">RFC 7247</a>, DOI 10.17487/RFC7247, May 2014,
               &lt;<a href="http://www.rfc-editor.org/info/rfc7247">http://www.rfc-editor.org/info/rfc7247</a>&gt;.

   [<a name="ref-RFC7258" id="ref-RFC7258">RFC7258</a>]   Farrell, S. and H. Tschofenig, "Pervasive Monitoring Is
               an Attack", <a href="./bcp188">BCP 188</a>, <a href="./rfc7258">RFC 7258</a>, DOI 10.17487/RFC7258, May
               2014, &lt;<a href="http://www.rfc-editor.org/info/rfc7258">http://www.rfc-editor.org/info/rfc7258</a>&gt;.

   [<a name="ref-RFC7457" id="ref-RFC7457">RFC7457</a>]   Sheffer, Y., Holz, R., and P. Saint-Andre, "Summarizing
               Known Attacks on Transport Layer Security (TLS) and
               Datagram TLS (DTLS)", <a href="./rfc7457">RFC 7457</a>, DOI 10.17487/RFC7457,
               February 2015, &lt;<a href="http://www.rfc-editor.org/info/rfc7457">http://www.rfc-editor.org/info/rfc7457</a>&gt;.

   [<a name="ref-RFC7572" id="ref-RFC7572">RFC7572</a>]   Saint-Andre, P., Houri, A., and J. Hildebrand,
               "Interworking between the Session Initiation Protocol
               (SIP) and the Extensible Messaging and Presence Protocol
               (XMPP): Instant Messaging", <a href="./rfc7572">RFC 7572</a>,
               DOI 10.17487/RFC7572, June 2015,
               &lt;<a href="http://www.rfc-editor.org/info/rfc7572">http://www.rfc-editor.org/info/rfc7572</a>&gt;.

   [<a name="ref-XEP-0138" id="ref-XEP-0138">XEP-0138</a>]  Hildebrand, J. and P. Saint-Andre, "Stream Compression",
               XSF XEP 0138, May 2009,
               &lt;<a href="http://xmpp.org/extensions/xep-0138.html">http://xmpp.org/extensions/xep-0138.html</a>&gt;.

   [<a name="ref-XEP-0170" id="ref-XEP-0170">XEP-0170</a>]  Saint-Andre, P., "Recommended Order of Stream Feature
               Negotiation", XSF XEP 0170, January 2007,
               &lt;<a href="http://xmpp.org/extensions/xep-0170.html">http://xmpp.org/extensions/xep-0170.html</a>&gt;.

   [<a name="ref-XEP-0198" id="ref-XEP-0198">XEP-0198</a>]  Karneges, J., Saint-Andre, P., Hildebrand, J., Forno, F.,
               Cridland, D., and M. Wild, "Stream Management", XSF XEP
               0198, June 2011,
               &lt;<a href="http://xmpp.org/extensions/xep-0198.html">http://xmpp.org/extensions/xep-0198.html</a>&gt;.

   [<a name="ref-XEP-0220" id="ref-XEP-0220">XEP-0220</a>]  Miller, J., Saint-Andre, P., and P. Hancke, "Server
               Dialback", XSF XEP 0220, August 2014,
               &lt;<a href="http://xmpp.org/extensions/xep-0220.html">http://xmpp.org/extensions/xep-0220.html</a>&gt;.

   [<a name="ref-XMPP-DNA" id="ref-XMPP-DNA">XMPP-DNA</a>]  Saint-Andre, P. and M. Miller, "Domain Name Associations
               (DNA) in the Extensible Messaging and Presence Protocol
               (XMPP)", Work in Progress, <a href="./draft-ietf-xmpp-dna-10">draft-ietf-xmpp-dna-10</a>, March
               2015.







<span class="grey">Saint-Andre &amp; Alkemade       Standards Track                    [Page 8]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-9" id="page-9" href="#page-9" class="invisible"> </a>
<span class="grey"><a href="./rfc7590">RFC 7590</a>                        XMPP TLS                       June 2015</span>


<span class="h2"><a class="selflink" name="appendix-A" href="#appendix-A">Appendix A</a>.  Implementation Notes</span>

   Some governments enforce legislation prohibiting the export of strong
   cryptographic technologies.  Nothing in this document ought to be
   taken as advice to violate such prohibitions.

Acknowledgements

   The authors would like to thank the following individuals for their
   input: Dave Cridland, Philipp Hancke, Olle Johansson, Steve Kille,
   Tobias Markmann, Matt Miller, and Rene Treffer.

   Roni Even caught several important issues in his review on behalf of
   the General Area Review Team.

   Ben Campbell, Spencer Dawkins, and Barry Leiba provided helpful input
   during IESG review.

   Thanks to Leif Johansson and Orit Levin as chairs of the UTA WG, Ben
   Campbell and Joe Hildebrand as chairs of the XMPP WG, and Stephen
   Farrell as the sponsoring Area Director.

Authors' Addresses

   Peter Saint-Andre
   &amp;yet

   EMail: peter@andyet.com
   URI:   <a href="https://andyet.com/">https://andyet.com/</a>


   Thijs Alkemade

   EMail: me@thijsalkema.de

















Saint-Andre &amp; Alkemade       Standards Track                    [Page 9]

</pre><br />
    <span class="noprint"><small><small>Html markup produced by rfcmarkup 1.119, available from
      <a href="https://tools.ietf.org/tools/rfcmarkup/">https://tools.ietf.org/tools/rfcmarkup/</a>
    </small></small></span>
  </div>
</body>
</html>
